#include <stdio.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

extern FILE *in, *out,*out1;
extern void initp(), fixpnf(), atxpxa(), riccnd(), chkd(double *y); 
extern void free_dmatrix(), free_dvector(), free_ivector(); 
extern double **dmatrix(), *dvector();
extern int *ivector();

void track(double ansae, double arcae )
{
  register int i,j, k;
  int iflag,nfe,ind,ip,*ipivot,n4;
  double  eps=1.0e-26, aa[1], arclen, sspar[8], *wa;
  double  *x, ansre, arcre;
  
  wa = dvector(0,30*nn+nn*nn+14*n2*n2);
  x = dvector(0,nn);
  ipivot =ivector(0,nn);

  initp(); 

  *x = 0.0;          /* Transfer bc, cc to array x  */
  *(x+1) = ac[0][0];
  k = 1;
  for(i=0;i< nc/2;i++){
   *(x+k) = ac[2*i+1][2*i]; 
   *(x+k+1) = ac[2*i+1][2*i+1]; 
   k += 2;
   }
  x[nc] = ac[nc-1][nc-1];

  toarray(nc,l,bc,(x+1+nc));

  k = 1 + nc + nc*l;
  for(i=1;i<m;i++)
   for(j=0;j<nc;j++){
    *(x+k) = cc[i][j];
    k += 1;
   }

  for(i=0;i<nn;i++) x0[i] = x[i+1];

   addmat3(a,a0,adot,n,n);
   addmat3(b,b0,bdot,n,m);
   addmat3(c,c0,cdot,l,n);
   addmat3(r1f,r10,r1dot,n,n);
   addmat3(r1if,r1i0,r1idot,n,n);
   addmat3(v1f,v10,v1dot,n,n);
   addmat3(r2f,r20,r2dot,m,m);
   addmat3(r2if,r2i0,r2idot,m,m);
   addmat3(v2f,v20,v2dot,l,l);

   
/* chkd(x); exit();   */

#if ((AIX) || (HP))
   rho(aa, x, x+1, wa, wa+nn+1, &ip);
#else
   rho_(aa, x, x+1, wa, wa+nn+1, &ip);
#endif


/* Compute average values of the initial homotopy map */ 
 
   sspar[0]  =  0.0;
   for(i=0;i<nn;i++)  sspar[0] += myabs(*(wa+i));
    sspar[0] /= nn;
   if(trace) fprintf(out, "\nThe initial homotopy  = %9.2E \n", sspar[0]);
   printf("\nThe initial homotopy  = %9.2E \n", sspar[0]);
 
   for(i=0;i<8; i++) *(sspar+i) = 0.0;
   sspar[4] = 0.05;  
   iflag = -2;
   ip = 0;
/* arcre = 1.0e-12;
   arcae = 1.0e-14;
   ansae = 1.0e-13; */
   ansre = ansae;
   arcre = arcae;   
 
/* Call tracking procedure             */ 
 
   for(i=0;i<10;i++){
   n4 = nn + 1;
#if ((AIX) || (HP))
   fixpnf(&nn,x,&iflag,&arcre,&arcae,&ansre,&ansae,&trace,aa,&nfe,
#else
   fixpnf_(&nn,x,&iflag,&arcre,&arcae,&ansre,&ansae,&trace,aa,&nfe,
#endif
          &arclen,wa,wa+n4,wa+2*n4,wa+3*n4,wa+5*n4+n4*n4,
          wa+6*n4+n4*n4, ipivot,wa+7*n4+n4*n4,wa+8*n4+n4*n4,
          wa+9*n4+n4*n4,wa+10*n4+n4*n4,sspar,wa+11*n4+n4*n4,&ip);
      if(iflag != 3) break;
    }
 
   printf("\niflag = %u  nfe = %u \n", iflag,nfe);
   if(trace) fprintf(out, "\niflag = %u  nfe = %u \n", iflag,nfe);

   printf("\nThe final lambda = %20.15E   gamma = %20.15E\n",*x,gf);
   fprintf(out1,"%u\n %u\n",iflag, nc);
   fprintf(out1,"%20.15E\n",gf);
   if(trace) fprintf(out, "\nThe final lambda = %20.15E\n",*x);
#if ((AIX) || (HP))
   rho(aa, x, x+1, wa, wa+n4, &ip);
#else
   rho_(aa, x, x+1, wa, wa+n4, &ip);
#endif


   sspar[0] = 0.0;
   for(i=0;i<nn;i++) sspar[0] += myabs(*(wa+i));
     sspar[0] /= nn;
   if(trace) fprintf(out, "\nThe final homotopy = %9.2E\n", sspar[0]);
   printf("\nThe final homotopy = %9.2E\n", sspar[0]);

/* Print Ac, Bc, Cc in input normal form */

      if (trace > 0){ 
      fprintf(out,"\n Ac\n");
      for(i=0;i<nc;i++)
       for(j=0;j<nc;j++) fprintf(out,"%d %d  %19.10E\n",i,j, ac[i][j]);
      fprintf(out,"\nBc\n");
      for(i=0;i<nc;i++)
        for(j=0;j<l;j++) fprintf(out,"%d %d %19.10E\n",i,j,bc[i][j]);
      fprintf(out,"\nCm\n");
      for(i=0;i<m;i++)
        for(j=0;j<nc;j++) fprintf(out,"%d %d %19.10E\n",i,j,cc[i][j]);
      }

      for(i=0;i<nc;i++)
       for(j=0;j<nc;j++) fprintf(out1,"%19.10E\n",ac[i][j]);
      for(i=0;i<nc;i++)
         fprintf(out1,"%19.10E\n",bc[i][0]);
      for(i=0;i<m;i++)
        for(j=0;j<nc;j++) fprintf(out1,"%19.10E\n",cc[i][j]);


/* Compute the eigenvalues of A and Ac */

     if(trace){
      fprintf(out,"\nThe eigenvalues of A\n");
      ip = 0;
      tmparray(a, tarray1,n,n);
#if ((AIX) || (HP))
      rg(&n1,&n,tarray1,er,ei,&ip,temp1,ipvl,uat,&nfe);
#else
      rg_(&n1,&n,tarray1,er,ei,&ip,temp1,ipvl,uat,&nfe);
#endif

      for(i=0;i<n;i++) fprintf(out,"%16.10E  %16.10E\n",er[i],ei[i]);

      fprintf(out,"\nThe eigenvalues of Am\n");
      ip = 0;
      tmparray(ac, tarray1,nc,nc);
      iflag = nc + 2;
#if ((AIX) || (HP))
      rg(&iflag,&nc,tarray1,er,ei,&ip,temp1,ipvl,uat,&nfe);
#else
      rg_(&iflag,&nc,tarray1,er,ei,&ip,temp1,ipvl,uat,&nfe);
#endif

      for(i=0;i<nc;i++) fprintf(out,"%16.10E  %16.10E\n",er[i],ei[i]);
    }

/* Compute the L^2 cost  */

   *sspar = 0; 
   mulmat1(qt,rt,ttemp1,nt,nt,nt);
   for(i=0;i<nt;i++) *sspar += ttemp1[i][i];
   if(trace) fprintf(out,"\nThe upper bound for the cost is %19.7E\n", *sspar);
   printf("\nThe upper bound for the cost is %19.7E\n", *sspar);
   fprintf(out1,"%19.10E\n", *sspar);

   trarray(at,uat,nt,nt);
   scmat(-1.0,vt,ttemp1,nt,nt);
   tmparray(ttemp1,ua,nt,nt);
   eps = 1.0e-26;
#if ((AIX) || (HP))
   atxpxa(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, &eps, &ip);
#else
   atxpxa_(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, &eps, &ip);
#endif

   tmpmatrix(ua,qt,nt,nt);
   mulmat1(qt,rt,ttemp1,nt,nt,nt);

   sspar[0] =0.0;
   for(i=0;i<nt;i++) sspar[0] += ttemp1[i][i];
   if(trace) fprintf(out,"\nThe cost is %19.7E\n", sspar[0]);
   printf("\nThe cost is %19.7E\n", sspar[0]);
   fprintf(out1,"%19.10E\n", sspar[0]);

 /*free(wa);
   free(x);
   free(ipivot); 
   free_dvector(wa,0,20*nn+nn*nn+10*n2*n2);
   free_dvector(x,0,nn);
   free_ivector(ipivot,0,nn);  */
} 
