#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

void jacbm(int k,int ll, double *y) 
/*
* JACBM -- evaluates kk-th column of Jacobian at given point
*           with respect to Bm. or w.r.t. Bm_kl 
* Input parameters: k, ll -- the index of the element of Bm
* Output parameters: y - evaluated function 
*/
{
      int ind;
      register int i,j;
      double alpha, eps = -1.0;
 
/* Compute derivative of Am w.r.t. Bmkl and save it in temp3 */
       alpha = - 2.0 * bmv[k][ll]* ome[k][k] / bmvbmt[k][k];   
       for(j=0;j<nm;j++){
         temp3[j][j] = - bmv[k][ll] * delta[k][j];
	 for(i=0;i<nm ;i++)
	  if(i != j)
          temp3[i][j]= -((delta[k][j] -delta[k][i]) * alpha * ami[i][j] 
               +alpha * delta[k][j]*bmvbmt[i][j] +ome[j][j] *delta[k][i]
               * bmv[j][ll] +ome[j][j] *bmv[i][ll] *delta[j][k] ) / 
                   (ome[j][j] -ome[i][i]);
       }

       setmat(0.0,att,nt,nt); /* Derivative of A tilde */
       for(i=n;i<nt;i++)
         for(j=n;j<nt;j++) att[i][j] = temp3[i-n][j-n];

       for(i=0;i<n;i++) /* Derivative of V tilde         */
	  for(j=0;j<n;j++) vtt[i][j]=0.0;  /* 11 block of Vt^(j)*/

       setmat(0.0,temp1,n,nm); /*BV E^(ll,k)--12 block of Vt^(j)*/
       for(i=0;i<n;i++) temp1[i][k] = bv[i][ll];
       for(i=0;i<n;i++) for(j=n;j<nt;j++) 
           {vtt[i][j]= temp1[i][j-n]; vtt[j][i]= vtt[i][j];}

       setmat(0.0,temp1,nm,nm); /* BmVE^(ll,k)+E^(k,ll)VBm^T */
       for(i=0;i<nm;i++) temp1[i][k] = bmv[i][ll];
       trans(temp1,temp2,nm,nm);
       addmat1(temp1,temp2,ttemp3,nm,nm);
       for(i=n;i<nt;i++)       /* 22 block of Vt^(j)      */ 
	  for(j=n;j<nt;j++) vtt[i][j]=ttemp3[i-n][j-n];
         
      mulmat1(att,qt,ttemp1,nt,nt,nt); /* Compute Q^(j)*/
      trans(ttemp1,ttemp2,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);
      addmat4(vtt,ttemp3,ttemp1,nt,nt);

      tmparray(ttemp1,tarray2,nt,nt);
#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rt,ttemp2,nt,nt,nt); /* Compute P^(j) */
      scmat(gaman2,ttemp2,ttemp2,nt,nt);
      addmat1(att,ttemp2,ttemp3,nt,nt);
      mulmat2(ttemp3,pt,ttemp1,nt,nt,nt);
      trans(ttemp1,ttemp2,nt,nt);
      addmat4(ttemp2,ttemp1,ttemp3,nt,nt);

      tmparray(ttemp3,tarray2,nt,nt);
#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
 
      mulmat2(ptd12,qt12,temp1,nm,nm,n); /* Jam^(j) = Z2^(j)*/
      mulmat2(pt12,qtd12,temp2,nm,nm,n);  
      addmat1(temp1,temp2,ttemp3,nm,nm);
      mulmat1(ptd2,qt2,temp1,nm,nm,nm);
      mulmat1(pt2,qtd2,temp2,nm,nm,nm);  
      addmat1(temp1,temp2,temp2,nm,nm);
      addmat1(ttemp3,temp2,ttemp1,nm,nm); 
 
      for(j=0;j<nm;j++) /* Mo^(j) in ttemp2        */
        for(i=j+1;i<nm;i++){
         ttemp2[i][j]= (ttemp1[i][j] -ttemp1[j][i]-mo[i][j]*alpha *
           (delta[j][k] -delta[i][k]) )/(ome[j][j] -ome[i][i]) ;
            ttemp2[j][i] = ttemp2[i][j];
        }
  
      for(i=0;i<nm;i++){
        ttemp2[i][i] = 0.00;
        for(j=0;j<nm ;j++)
	 if(i != j)
          ttemp2[i][i] += temp3[i][j]*mo[j][i]+ami[i][j]*ttemp2[j][i];
        ttemp2[i][i] = (-temp3[i][i]*mo[i][i] - ttemp2[i][i]) /ami[i][i];
	   
      } 
     setmat(0.0,temp1,nm,nm);
     temp1[k][k] = alpha;
 
     mulmat1(temp1,mo,temp2,nm,nm,nm); /*  Mc^(j) in ttemp3  */ 
     mulmat1(ome,ttemp2,temp3,nm,nm,nm);
     addmat1(temp2,temp3,temp1,nm,nm);
     addmat4(temp1,ttemp1,ttemp3,nm,nm);
 
/* Compute derivatives of H_Bm */

        setmat(0.0,temp1,nm,m);
        for(j=0;j<m;j++)
          temp1[k][j] = v[ll][j];
        addmat1(pt2,mc,temp2,nm,nm); 
 	mulmat1(temp2,temp1,temp3,nm,m,nm);

        mulmat2(ptd12,bv,temp1,nm,m,n);
        addmat1(temp1,temp3,temp2,nm,m);

 	addmat1(ptd2,ttemp3,temp1,nm,nm);
 	mulmat1(temp1,bmv,temp3,nm,m,nm);
        addmat1(temp2,temp3,temp1,nm,m);
        toarray(nm,m,temp1,y);
 
/* Compute derivatives of H_Cm */
/* Original terms              */ 
        addmat1(qtd2,ttemp2,temp1,nm,nm);
        mulmat1(rcm,temp1,temp2,l,nm,nm);
 	mulmat1(rc,qtd12,temp3,l,nm,n);
 	addmat3(temp2,temp3,temp1,l,nm);

        hcm();  
 	addmat1(temp1,temp3,temp2,l,nm);
        toarray(l,nm,temp2,y+m*nm);
} 
