#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

void jaccm(int k,int ll, double *y)
/* 
* JACCM evaluates kk-th column of Jacobian at given point w.r.t. Cm.
* Input parameters: k, ll -- the index of the element of Cm 
* Output parameters: * y - evaluated function
*/
{
      int ind;
      register int i,j;
      double beta, eps = -1.0;
 
/* Compute derivative of Am w.r.t. Cmkl and save it in temp3 */
       beta = 2.0 * rcm[k][ll]/ bmvbmt[ll][ll];   
       for(j=0;j<nm;j++){
         temp3[j][j] = 0.00 ;
         for(i=0;i<nm ;i++)
	  if( i != j)
            temp3[i][j]= (delta[ll][i]*rcm[k][j]+delta[ll][j]  
                   *rcm[k][i] -beta * delta[ll][j] *bmvbmt[i][j] 
                   -(delta[j][ll]- delta[i][ll])*beta*ami[i][j])/ 
                   (ome[j][j] -ome[i][i]);
       }

       setmat(0.0, att, nt,nt); /* Derivative of A tilde   */
       for(i=n;i<nt;i++)
         for(j=n;j<nt;j++) att[i][j] = temp3[i-n][j-n];

       for (i=0;i<n;i++) /* Derivative of R tilde          */  
	  for(j=0;j<n;j++) rtt[i][j]=0.0; 
       
       setmat(0.0,temp1,n,nm) ; /* C^T R E^(k,l)--12 block of Rt^(j) */  
       for(j=0;j<n;j++) temp1[j][ll] = - rc[k][j];
       for(i=0;i<n;i++) for(j=n;j<nt;j++) 
           {rtt[i][j]= temp1[i][j-n]; rtt[j][i]= rtt[i][j];}

       setmat(0.0,temp1,nm,nm); /* Cm^tRE^(k,ll)+E^(ll,k) R Cm  */
       for(j=0;j<nm;j++) temp1[j][ll] = rcm[k][j];
       trans(temp1,temp2,nm,nm);
       addmat1(temp1,temp2,ttemp1,nm,nm);
       for(i=n;i<nt;i++) /*  22 block of Rt^(j) */
	  for(j=n;j<nt;j++)rtt[i][j]=ttemp1[i-n][j-n];

      mulmat1(att,qt,ttemp1,nt,nt,nt); /* Compute Q^(j) */
      trans(ttemp1,ttemp2,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);

      scmat(gaman2,rtt,ttemp2,nt,nt);
      mulmat1(ttemp2,qt,ttemp1,nt,nt,nt);
      mulmat1(qt,ttemp1,ttemp2,nt,nt,nt);
      addmat4(ttemp2,ttemp3,ttemp1,nt,nt);

      tmparray(ttemp1,tarray2,nt,nt);
#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif
      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rt,ttemp2,nt,nt,nt); /* Compute P^(j) */
      mulmat1(qt,rtt,ttemp1,nt,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);
      scmat(gaman2,ttemp3,ttemp3,nt,nt);
      addmat1(att,ttemp3,ttemp1,nt,nt);
      mulmat2(ttemp1,pt,ttemp2,nt,nt,nt);
      trans(ttemp2,ttemp3,nt,nt);
      addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
      addmat4(rtt,ttemp1,ttemp3,nt,nt);

      tmparray(ttemp3,tarray2,nt,nt);
#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif
      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
         
      mulmat2(ptd12,qt12,temp1,nm,nm,n); /* Jam^(j) = Z2^(j) */
      mulmat2(pt12,qtd12,temp2,nm,nm,n);  
      addmat1(temp1,temp2,ttemp2,nm,nm);
      mulmat2(ptd2,qt2,temp1,nm,nm,nm);
      mulmat2(pt2,qtd2,temp2,nm,nm,nm);  
      addmat1(temp1,temp2,temp2,nm,nm);
      addmat1(ttemp2,temp2,ttemp1,nm,nm); 
 
       for(j=0;j<nm;j++) /* Mo^(j) in ttemp2   */
         for(i=j+1;i<nm;i++){
            ttemp2[i][j]= ( (ttemp1[i][j] -ttemp1[j][i])-mo[i][j]*beta *
                 (delta[j][ll] -delta[i][ll]))/(ome[j][j]-ome[i][i]); 
            ttemp2[j][i]=ttemp2[i][j];
         }
  
      for(i=0;i<nm;i++){
        ttemp2[i][i] = 0.0;
        for(j=0;j<nm ;j++)
	 if(i != j)
           ttemp2[i][i] += temp3[i][j]*mo[j][i]+ami[i][j]*ttemp2[j][i];
        ttemp2[i][i] /= -ami[i][i];
     } 
      setmat(0.0,temp1,nm,nm);
      temp1[ll][ll] = beta;

        mulmat1(temp1,mo,temp2,nm,nm,nm); /* Mc^(j) in ttemp3  */ 
	mulmat1(ome,ttemp2,temp1,nm,nm,nm);
        addmat1(temp1,temp2,temp3,nm,nm);
        addmat4(temp3,ttemp1,ttemp3,nm,nm);
 
/* Compute derivative of H_Bm  */
 
      mulmat2(ptd12,bv,temp2,nm,m,n);
      addmat1(ptd2,ttemp3,temp3,nm,nm);
      mulmat1(temp3,bmv,temp1,nm,m,nm);
      addmat1(temp1,temp2,temp3,nm,m);
      toarray(nm,m,temp3,y);
 
/* Compute derivative of H_Cm       */
/* Originial terms                  */ 
       addmat1(ttemp2,qtd2,temp1,nm,nm);
       mulmat1(rcm,temp1,temp2,l,nm,nm);
       mulmat1(rc,qtd12,temp3,l,nm,n);
       addmat3(temp2,temp3,temp1,l,nm);

       addmat1(qt2,mo,temp2,nm,nm);
       eps = 0.5 * gaman2;
       scmat(eps,temp4,temp3,nm,nm);
       addmat1(temp2,temp3,ttemp3,nm,nm);
       setmat(0.00,temp2,l,nm);
       for(j=0;j<nm;j++) temp2[k][j] = ttemp3[ll][j];
       mulmat1(r,temp2,temp3,l,nm,l);
       addmat1(temp1,temp3,temp1,l,nm);
       
       hcm();
       addmat1(temp1,temp3,temp2,l,nm);
       toarray(l,nm,temp2,y+m*nm);
}
