#include "macro.h"
#include "eglobal.h"

extern void jaclam(), jacbm(), jaccm();

#if ((AIX) || (HP))
void rhojac(double *aa, double *lambda,double *x,double *y,int *k,
#else
void rhojac_(double *aa, double *lambda,double *x,double *y,int *k,
#endif
       double *p,int *ip)
 
/* RHOJAC evaluates kk-th column of Jacobian at given point.
*
* Input parameters: lambda,x - input point (lambda,x)
* kk - column number
*
* Output parameters:
* y - evaluated function
*/
{ 
      int ik,jl, kk;

/* Derivatives with respect to Bmij          */

   kk = *k;
   if (kk > 1 && kk <= m*nm+1){ 
      kk--;
      compij(kk,m,ik,jl);
      jacbm(ik,jl,y);
      return;
    }
      
/* Derivatives with respect to Cmij          */

   if (kk > m*nm + 1) {
      kk -= m*nm + 1;
      compij(kk,nm,ik,jl);
      jaccm(ik,jl,y);
      return;
   }   

/* Derivatives with respect to lambda        */

   if (kk == 1) {
       jaclam(*lambda,y);
    }
}


