#include <stdio.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

extern FILE *in, *out;
extern void initp(), fixpnf(), atxpxa(), riccnd(); 
extern void free_dmatrix(), free_dvector(), free_ivector(); 
extern double **dmatrix(), *dvector();
extern int *ivector();

void track(double ansae, double arcae )
{
  int i,j;
  int iflag,nfe,ip,*ipivot, n4, trace =0;
  double  eps=1.0e-26, aa[1], arclen, sspar[8], f10av, f20av;
  double  *x, ansre, arcre, *wa;
  
  wa = dvector(0,20*nn+nn*nn + 10*n1*n1);
  x = dvector(0,nn);
  ipivot =ivector(0,nn);

  initp();

  *x = 0.0;          /* Transfer bmi, cmi to array x  */
  toarray(nm,m,bmi,(x+1));
  toarray(l,nm,cmi,(x+1+nm*m));

  addmat3(a,a0,adot,n,n);
  addmat3(b,b0,bdot,n,m);
  addmat3(c,c0,cdot,l,n);

  setmat(0.0,delta,nm,nm);
  for(i=0;i<nm;i++) delta[i][i] = 1.0;

#if ((AIX) || (HP))
  rho(aa, x, x+1, wa, wa+nn+1, &ip);
#else
  rho_(aa, x, x+1, wa, wa+nn+1, &ip);
#endif
   
/* Compute average values of the initial homotopy map */ 
 
   f10av= 0.0;
   for(i=0;i<nn;i++) f10av += myabs(*(wa+i));
    f10av /= nn;
   if(f10av > 1.0e-3)
    printf("\nThe initial solution is %9.2E\n", f10av);
 
 
   for(i=0;i<8; i++) *(sspar+i) = 0.0;
/* sspar[4] = 0.01; */  
   iflag = -2;
   ip = 0;
   ansre = ansae;
   arcre = arcae;
 
/* Call tracking procedure             */ 
 
   for(i=0;i<10;i++){

   n4 = nn + 1;
#if ((AIX) || (HP))
   fixpnf(&nn,x,&iflag,&arcre,&arcae,&ansre,&ansae,&trace,aa,&nfe,
#else
   fixpnf_(&nn,x,&iflag,&arcre,&arcae,&ansre,&ansae,&trace,aa,&nfe,
#endif
          &arclen,wa,wa+n4,wa+2*n4,wa+3*n4,wa+5*n4+n4*n4,
          wa+6*n4+n4*n4, ipivot,wa+7*n4+n4*n4,wa+8*n4+n4*n4,
          wa+9*n4+n4*n4,wa+10*n4+n4*n4,sspar,wa+11*n4+n4*n4,&ip);
      if(iflag != 3) break;
    }

   fprintf(out, "%u\n", iflag);
   fprintf(out, "%20.15E\n",*x);   
/* printf("\niflag = %u  nfe = %u \n", iflag,nfe); */

#if ((AIX) || (HP))
   rho(aa, x, x+1, wa, wa+n4, &ip);
#else
   rho_(aa, x, x+1, wa, wa+n4, &ip);
#endif
   
   f10av = 0.0;
   for(i=0;i<nn;i++) f10av += myabs(*(wa+i));
   f10av /= nn;
   if(f10av > 1.0e-7)
    printf("\nThe final solution = %9.2E\n", f10av);
 
/* Compute the L^2 cost  */
   f10av = 0;
   mulmat1(qt,rt,ttemp1,nt,nt,nt);
   for(i=0;i<nt;i++) f10av += ttemp1[i][i];
   fprintf(out,"%19.7E\n", f10av);

   trarray(at,uat,nt,nt);
   scmat(-1.0,vt,ttemp1,nt,nt);
   tmparray(ttemp1,ua,nt,nt);
#if ((AIX) || (HP))
   atxpxa(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, &eps, &ip);
#else
   atxpxa_(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, &eps, &ip);
#endif

   tmpmatrix(ua,qt,nt,nt);
   mulmat1(qt,rt,ttemp1,nt,nt,nt);

   f10av =0.0;
   for(i=0;i<nt;i++) f10av += ttemp1[i][i];
   fprintf(out, "%19.7E\n",f10av);

/* Print Am, Bm, Cm in input normal form */
      
      for(i=0;i<nm;i++)
        for(j=0;j<nm;j++) fprintf(out,"%19.10E\n", ami[i][j]);
      for(i=0;i<nm;i++) 
        for(j=0;j<m;j++) fprintf(out,"%19.10E\n", bmi[i][j]);
      for(i=0;i<l;i++)
        for(j=0;j<nm;j++) fprintf(out,"%19.10E\n", cmi[i][j]);

/* Frees the dynamical variables */

   free_dvector(wa,0,20*nn+nn*nn + 10*n1*n1);
   free_dvector(x,0,nn);
   free_ivector(ipivot,0,nn);
} 
