function [Aclqg,Bclqg,Cclqg,cost] = LQGcont(AA,BB,CC,DD,D1,D2,E1,E2)
%
%
% Form Weights(LQR):
%
	R22lqg = E2'*E2;
	V22lqg = D2*D2';
	V11lqg = D1*D1';
	R11lqg = E1'*E1;
	SSlqg = BB*inv(R22lqg)*BB';
	SBlqg = CC'*inv(V22lqg)*CC;
	Qlqg = are(AA',SBlqg,V11lqg);
	Plqg = are(AA,SSlqg,R11lqg);
% 
% Design LQG Controller
%
	Cclqg = (-1)*inv(R22lqg)*BB'*Plqg;
	Bclqg = Qlqg*CC'*inv(V22lqg);
	Aclqg = AA+BB*Cclqg-Bclqg*CC-Bclqg*DD*Cclqg;
%
%  Determine Closed-Loop system:
%
	ATlqg = [AA,BB*Cclqg;Bclqg*CC,Aclqg+Bclqg*DD*Cclqg];
	DTlqg = [D1;Bclqg*D2];
	ETlqg = [E1,E2*Cclqg];
%
	VTlqg = DTlqg*DTlqg';
	RTlqg = ETlqg'*ETlqg;
%
% evaluate cost
%
	QTlqg = lyap(ATlqg,VTlqg);
%
	cost = trace(QTlqg*RTlqg);
