
function [am,bm,cm, cost] = morh2op(a,b,c,nm,meth,init,c1,c2)

% Find the sizes of the system and check the dimensions 
[nr,nc] = size(a);
if (nr ~= nc), error('Nonsquare A matrix'); end;
if (nr > 20), error('Use h2inf, or h2ly instead'); end;

[n,m] = size(b);
if (nr~=n), error('Incorrectly dimensioned B matrix'); end;

[l,nc] = size(c);
if (nc~=n), error('Incorrectly dimensioned C matrix'); end;

% Check the size of the reduced order model
if (nm >= n), error('Incorrectly dimensioned reduced model'); end;

% Set the starting gamma and final gamma


% Set the precision for HOMPACK routines


% Write the data into file 'in.dat' to be read by the executable
in = fopen('in.dat','w');

fprintf(in, '%u  %u\n',meth,init);
fprintf(in, '%u  %u  %u  %u\n',n,nm,m,l);
fprintf(in, '%e  %e\n',c1,c2);

for i=1:n
  for j=1:n
    fprintf(in, '%17.9e\n',a(i,j));
  end
end
   
for i=1:n
  for j=1:m
    fprintf(in, '%17.9e\n',b(i,j));
  end
end

for i=1:l
  for j=1:n
    fprintf(in, '%17.9e\n',c(i,j));
  end
end

fclose(in);

% Execute the function to find the solution (Am, Bm, Cm)
!opt   

load out.dat;

iflag = out(1,1);
lambda = out(2,1); 

if(iflag == 2),error('Specified error tolerrance can not be met.'); end;

if(iflag == 3),error('Stepnf  has been called 1000 times.'); end;

if(iflag == 4),error('jacobian matrix does not have full rank'); end;

if(iflag == 5),printf('Tracking algorithm has lost the zero curve.\n'), 
error('Use smaller arcre and ansre in oprjeq.m and try again.'); end;

%if(iflag == 6), 
%fprintf(1,'The final lambda %e\n', lambda), 
%error('Make ancre and ansre in oprjeq.m larger and try again '); end; 

cost = out(3,1);

k = 3;

for i=1:nm
 for j=1:nm
 k=k+1;
 am(i,j) = out(k,1);
 end
end

for i=1:nm
 for j=1:m
 k=k+1;
 bm(i,j) = out(k,1);
 end
end

for i=1:l
 for j=1:nm
 k=k+1;
 cm(i,j) = out(k,1);
 end
end

