      subroutine atxpxa(a,u,c,n,na,nu,nc,eps,fail)
*
* Code for solving Lyapunov and Sylvester equations
* Bartels and Stewart, Comm. of the ACM, vol. 15, pp. 820-826, 1972
*
      integer n,na,nu,nc,fail,n1,nm1,i,j,k
      double precision a(na,1),u(nu,1),c(nc,1)
      double precision eps
*
      n1 = n + 1
      nm1 = n - 1
*
      if (eps .lt. .0) goto 15
      call hshldr(a,n,na)
      call bckmlt(a,u,n,na,nu)
      do 10 i = 1,nm1
        a(i+1,i) = a(i,n1)
10    continue
      call schur(a,u,n,na,nu,eps,fail)
      if (fail .ne. 0) return
*
15    do 20 i = 1,n
        c(i,i) = .5d0 * c(i,i)
20    continue
      do 40 i = 1,n
        do 30 j = 1,n
          a(n1,j) = 0.d0
          do 30 k = i,n
            a(n1,j) = a(n1,j) + c(i,k) * u(k,j)
30      continue
        do 40 j = 1,n
          c(i,j) = a(n1,j)
40     continue
       do 60 j = 1,n
         do 50 i = 1,n
           a(i,n1) = 0.d0
           do 50 k = 1,n
             a(i,n1) = a(i,n1) + u(k,i) * c(k,j)
50       continue
         do 60 i = 1,n
           c(i,j) = a(i,n1)
60     continue
       do 70 i = 1,n
         do 70 j = i,n
           c(i,j) = c(i,j) + c(j,i)
           c(j,i) = c(i,j)
70     continue
*
       call symslv(a,c,n,na,nc)
*
       do 80 i = 1,n
         c(i,i) = .5d0 * c(i,i)
80     continue
       do 100 i = 1,n
         do 90 j = 1,n
           a(n1,j) = 0.d0
           do 90 k = i,n
             a(n1,j) = a(n1,j) + c(i,k) * u(j,k)
90       continue
         do 100 j = 1,n
           c(i,j) = a(n1,j)
100    continue
       do 120 j = 1,n
         do 110 i = 1,n
           a(i,n1) = 0.d0
           do 110 k = 1,n
             a(i,n1) = a(i,n1) + u(i,k) * c(k,j)
110      continue
         do 120 i = 1,n
           c(i,j) = a(i,n1)
120    continue
       do 130 i = 1,n
         do 130 j = i,n
           c(i,j) = c(i,j) + c(j,i)
           c(j,i) = c(i,j)
130    continue
*
      return
      end
