      subroutine axpxb(a,u,m,na,nu,b,v,n,nb,nv,c,nc,epsa,epsb,fail)
*
* Code for solving Lyapunov and Sylvester equations
* Bartels and Stewart, Comm. of the ACM, vol. 15, pp. 820-826, 1972
*
      integer m,na,nu,n,nb,nv,nc,fail,m1,mm1,n1,nm1,i,j,k
      double precision a(na,1),u(nu,1),b(nb,1),v(nv,1),c(nc,1)
      double precision epsa,epsb,temp
*
      m1 = m + 1
      mm1 = m - 1
      n1 = n + 1
      nm1 = n - 1
*
      if (epsa .lt. .0) goto 35
      if (mm1 .eq. 0) goto 15
      do 10 i = 2,m
        do 10 j = 1,i-1
          temp = a(i,j)
          a(i,j) = a(j,i)
          a(j,i) = temp
10    continue
*
15    continue
      call hshldr(a,m,na)
      call bckmlt(a,u,m,na,nu)
      if (mm1 .eq. 0) goto 25
*
      do 20 i = 1,mm1
        a(i+1,i) = a(i,m1)
20    continue
      call schur(a,u,m,na,nu,epsa,fail)
      if (fail .ne. 0) return
*
25    continue
      do 30 i = 2,m
        do 30 j = 1,i-1
          temp = a(i,j)
          a(i,j) = a(j,i)
          a(j,i) = temp
30    continue
*
35    continue
      if (epsb .lt. .0) goto 45
      call hshldr(b,n,nb)
      call bckmlt(b,v,n,nb,nv)
      if (nm1 .eq. 0) goto 45
*
      do 40 i = 1,nm1
        b(i+1,i) = b(i,n1)
40    continue
      call schur(b,v,n,nb,nv,epsb,fail)
      fail = -fail
      if (fail .ne. 0) return
*
45    continue
      do 60 j = 1,n
        do 50 i = 1,m
          a(i,m1) = .0
          do 50 k = 1,m
            a(i,m1) = a(i,m1) + u(k,i) * c(k,j)
50      continue
*
        do 60 i = 1,m
          c(i,j) = a(i,m1)
60    continue
*
      do 80 i = 1,m
        do 70 j = 1,n
          b(n1,j) = .0
          do 70 k = 1,n
            b(n1,j) = b(n1,j) + c(i,k) * v(k,j)
70      continue
        do 80 j = 1,n
          c(i,j) = b(n1,j)
80    continue
*
      call shrslv(a,b,c,m,n,na,nb,nc)
*
      do 100 j = 1,n
        do 90 i = 1,m
          a(i,m1) = .0
          do 90 k = 1,m
            a(i,m1) = a(i,m1) + u(i,k) * c(k,j)
90      continue
        do 100 i = 1,m
          c(i,j) = a(i,m1)
100   continue
*
      do 120 i = 1,m
        do 110 j = 1,n
          b(n1,j) = .0
          do 110 k = 1,n
            b(n1,j) = b(n1,j) + c(i,k) * v(j,k)
110     continue
        do 120 j = 1,n
          c(i,j) = b(n1,j)
120   continue
*
      return
      end
