      subroutine bckmlt(a,u,n,na,nu)
*
* Code for solving Lyapunov and Sylvester equations
* Bartels and Stewart, Comm. of the ACM, vol. 15, pp. 820-826, 1972
*
      integer n,na,nu,n1,nm1,nm2,ll,l,l1,i,j
      double precision a(na,1),u(nu,1),sum,p
*
      n1 = n + 1
      nm1 = n - 1
      nm2 = n - 2
      u(n,n) = 1.
*
      if (nm1 .eq. 0) return
      u(nm1,n) = .0
      u(n,nm1) = .0
      u(nm1,nm1) = 1.
*
      if (nm2 .eq. 0) return
      do 40 ll = 1,nm2
        l = nm2 - ll + 1
        l1 = l + 1
        if (a(n1,l) .eq. .0) goto 25
*
        do 20 j = l1,n
          sum = .0
          do 10 i = l1,n
            sum = sum + a(i,l) * u(i,j)
10        continue
*
          p = sum / a(n1,l)
          do 20 i = l1,n
            u(i,j) = u(i,j) - a(i,l) * p
20      continue
*
25      continue
        do 30 i = l1,n
          u(i,l) = .0
          u(l,i) = .0
30      continue
        u(l,l) = 1.
*
40    continue
*
      return
      end
