      subroutine cont(ld,n,nm,m,l,nn,inp,trace,lwarr,c1,c2,arcre,ansre,
     & a,b,c,v,r,y,iflag,ipivot,d,bvbt,ctrc,f10,f20,f30,warr)
*
* Subroutine CONT is the interface between the main program CON and
* CONT1. Its purpose is to pass all parameters from the main program
* and organize working storage as needed for CONT1.
*
* Input parameters:
* ld - leading dimension for all matrices except QR, at least n+1
* n,nm,m,l - dimensions of the system (A,B,C) and model (Am,Bm,Cm)
* nn - Jacobian dimension (2*n*nm + nm*nm)
* inp - not used
* trace - logical i/o unit for output
* lwarr - length of warr
* c1,c2 - D is defined as D = -c1 * I + c2 * A
* arcre - relative error allowed of normal flow iterations along the curve
* ansre - relative error of the answer at lambda = 1
* a,b,c - system (A,B,C)
* v,r - white noise intensity V and weighting matrix R
* y - starting point (lambda,W,U,Sigma)
*
* Output parameters:
* y - final point (lambda,W,U,Sigma)
* iflag - flag returned by FIXPNF;
*         except if length of warr is unsufficient, then iflag = 99
*
* Working storage (user provided):
* ipivot(nn+1) - integer working array
* d,bvbt,ctrc - D, B V B^t, C^t R C
* warr(32*ld*ld+11*(nn+1)+nn*(nn+2)+nn*(nn+13)/2) - working array
*
      integer iflag,inp,ipivot(nn+1),l,ld,lwarr,m,n,n1,nm,nn,trace,z
      double precision a(ld,ld),ansre,arcre,b(ld,ld),bvbt(ld,ld)
      double precision c(ld,ld),c1,c2,ctrc(ld,ld),d(ld,ld)
      double precision f10(ld,ld),f20(ld,ld),f30(ld,ld)
      double precision r(ld,ld),v(ld,ld),warr(1),y(nn+1)
*
      z = ld * ld
      n1 = nn + 1
      if (lwarr .lt. 32*z+11*n1+nn*(nn+2)+nn*(nn+13)/2) then
        iflag = 99
        return
      endif
*
      call cont1(ld,n,nm,m,l,nn,inp,trace,c1,c2,arcre,ansre,a,b,c,v,r,
     & y,iflag,ipivot,d,bvbt,ctrc,warr(1),
     & warr(z+1),warr(2*z+1),warr(3*z+1),warr(4*z+1),warr(5*z+1),
     & f10,f20,f30,warr(9*z+1),warr(10*z+1),
     & warr(11*z+1),warr(12*z+1),warr(13*z+1),warr(14*z+1),warr(15*z+1),
     & warr(16*z+1),warr(32*z+1),warr(32*z+n1+1),warr(32*z+2*n1+1),
     & warr(32*z+3*n1+1),warr(32*z+4*n1+1),warr(32*z+5*n1+1),
     & warr(32*z+6*n1+1),warr(32*z+7*n1+1),warr(32*z+8*n1+1),
     & warr(32*z+9*n1+1),warr(32*z+10*n1+1),warr(32*z+11*n1+1),
     & warr(32*z+11*n1+nn*(nn+2)+1))
*
      return
      end
