      subroutine hshldr(a,n,na)
*
* Code for solving Lyapunov and Sylvester equations
* Bartels and Stewart, Comm. of the ACM, vol. 15, pp. 820-826, 1972
*
      integer n,na,nm2,n1,l,l1,i,j
      double precision a(na,1),max,sum,s,p
*
      nm2 = n - 2
      n1 = n + 1
      if (n .eq. 1) return
      if (n .gt. 2) goto 5
      a(1,n1) = a(2,1)
      return
*
5     continue
      do 80 l = 1,nm2
        l1 = l + 1
        max = .0
*
        do 10 i = l1,n
          max = dmax1(max,dabs(a(i,l)))
10      continue
*
        if (max .ne. .0) goto 20
        a(l,n1) = .0
        a(n1,l) = .0
        goto 80
*
20      continue
        sum = .0
        do 30 i = l1,n
          a(i,l) = a(i,l) / max
          sum = sum + a(i,l) ** 2
30      continue
*
        s = sign(sqrt(sum),a(l1,l))
        a(l,n1) = -max * s
        a(l1,l) = s + a(l1,l)
        a(n1,l) = s * a(l1,l)
*
        do 50 j = l1,n
          sum = .0
          do 40 i = l1,n
            sum = sum + a(i,l) * a(i,j)
40        continue
*
          p = sum / a(n1,l)
          do 50 i = l1,n
            a(i,j) = a(i,j) - a(i,l) * p
50      continue
*
        do 70 i = 1,n
          sum = .0
          do 60 j = l1,n
            sum = sum + a(i,j) * a(j,l)
60        continue
*
          p = sum / a(n1,l)
          do 70 j = l1,n
            a(i,j) = a(i,j) - p * a(j,l)
70      continue
*
80    continue
      a(n-1,n1) = a(n,n-1)
*
      return
      end
