      subroutine symslv(a,c,n,na,nc)
*
* Code for solving Lyapunov and Sylvester equations
* Bartels and Stewart, Comm. of the ACM, vol. 15, pp. 820-826, 1972
*
      integer n,na,nc,k,kk,dk,km1,l,ll,dl,ldl,i,ia,j,nsys
      double precision a(na,1),c(nc,1)
      double precision t,p
      common /slvblk/ t(5,5),p(5),nsys
*
      l = 1
10    dl = 1
      if (l .eq. n) goto 20
      if (a(l+1,l) .ne. .0) dl = 2
20    ll = l + dl - 1
      k = l
30    km1 = k - 1
      dk = 1
      if (k .eq. n) goto 35
      if (a(k+1,k) .ne .0) dk = 2
35    kk = k + dk - 1
      if (k .eq. l) goto 45
      do 40 i = k,kk
        do 40 j = l,ll
          do 40 ia = l,km1
            c(i,j) = c(i,j) - a(ia,i) * c(ia,j)
40    continue
45    if (dl .eq. 2) goto 60
      if (dk .eq. 2) goto 50
      t(1,1) = a(k,k) + a(l,l)
      if (t(1,1) .eq. .0) stop
      c(k,l) = c(k,l) / t(1,1)
      goto 90
50    t(1,1) = a(k,k) + a(l,l)
      t(1,2) = a(kk,k)
      t(2,1) = a(k,kk)
      t(2,2) = a(kk,kk) + a(l,l)
      p(1) = c(k,l)
      p(2) = c(kk,l)
      nsys = 2
      call sysslv
      c(k,l) = p(1)
      c(kk,l) = p(2)
      goto 90
60    if (dk .eq. 2) goto 70
      t(1,1) = a(k,k) + a(l,l)
      t(1,2) = a(ll,l)
      t(2,1) = a(l,ll)
      t(2,2) = a(k,k) + a(ll,ll)
      p(1) = c(k,l)
      p(2) = c(k,ll)
      nsys = 2
      call sysslv
      c(k,l) = p(1)
      c(k,ll) = p(2)
      goto 90
70    if (k .ne. l) goto 80
      t(1,1) = a(l,l)
      t(1,2) = a(ll,l)
      t(1,3) = 0.d0
      t(2,1) = a(l,ll)
      t(2,2) = a(l,l) + a(ll,ll)
      t(2,3) = t(1,2)
      t(3,1) = 0.d0
      t(3,2) = t(2,1)
      t(3,3) = a(ll,ll)
      p(1) = .5d0 * c(l,l)
      p(2) = c(ll,l)
      p(3) = .5d0 * c(ll,ll)
      nsys = 3
      call sysslv
      c(l,l) = p(1)
      c(ll,l) = p(2)
      c(l,ll) = p(2)
      c(ll,ll) = p(3)
      goto 90
80    t(1,1) = a(k,k) + a(l,l)
      t(1,2) = a(kk,k)
      t(1,3) = a(ll,l)
      t(1,4) = 0.d0
      t(2,1) = a(k,kk)
      t(2,2) = a(kk,kk) + a(l,l)
      t(2,3) = 0.d0
      t(2,4) = t(1,3)
      t(3,1) = a(l,ll)
      t(3,2) = 0.d0
      t(3,3) = a(k,k) + a(ll,ll)
      t(3,4) = t(1,2)
      t(4,1) = 0.d0
      t(4,2) = t(3,1)
      t(4,3) = t(2,1)
      t(4,4) = a(kk,kk) + a(ll,ll)
      p(1) = c(k,l)
      p(2) = c(kk,l)
      p(3) = c(k,ll)
      p(4) = c(kk,ll)
      nsys = 4
      call sysslv
      c(k,l) = p(1)
      c(kk,l) = p(2)
      c(k,ll) = p(3)
      c(kk,ll) = p(4)
90    k = k + dk
      if (k .le. n) goto 30
      ldl = l + dl
      if (ldl .gt. n) return
      do 120 j = ldl,n
        do 100 i = l,ll
          c(i,j) = c(j,i)
100     continue
        do 120 i = j,n
          do 110 k = l,ll
            c(i,j) = c(i,j) - c(i,k) * a(k,j) - a(k,i) * c(k,j)
110       continue
          c(j,i) = c(i,j)
120   continue
      l = ldl
      goto 10
*
      end
