#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

void hcmterms()
{
	double eps;

/* Compute terms in derivatives of Hcm(lambda,x)         
   ttemp1 = Z2^(j) and temp1 can not be used. */

        mulmat1(ptd1,qt1,temp2,n,n,n); /* Z1^(j) in ttemp3 */
        mulmat1(pt1,qtd1,temp3,n,n,n);
        addmat1(temp2,temp3,ttemp3,n,n); 

        mulmat3(ptd12, qt12,temp2,n,n,nm);
        mulmat3(pt12, qtd12,temp3,n,n,nm);
        addmat1(temp2,temp3,ttemp2,n,n); 
        addmat1(ttemp3,ttemp2,ttemp3,n,n);
        mulmat2(ttemp3,qt12,temp2,n,nm,n);/* Z1^{t(j)} Q12 in temp2*/

        mulmat2(ptd12,qt1,ttemp3,nm,n,n); /* Z21^(j) in ttemp3 */        
        mulmat2(pt12,qtd1,ttemp2,nm,n,n);
        addmat1(ttemp3,ttemp2,att,nm,n);
        mulmat3(ptd2,qt12,ttemp2,nm,n,nm);
        mulmat3(pt2,qtd12,ttemp3,nm,n,nm);
        addmat1(ttemp3,ttemp2,rtt,nm,n); 
        addmat1(att,rtt,ttemp3,nm,n); 
        mulmat2(ttemp3,qt2,ttemp2,n,nm,nm);/* Z21^{t(j)} Q2 in ttemp2*/

/*Z1^{t(j)} Q12 + Z21^{t(j)} Q2 in temp2*    */
        addmat1(temp2,ttemp2,temp2,n,nm); 

/* Z1^t Q12^(j) + Z21^t Q2^(j) in ttemp2   */
        mulmat2(zt1,qtd12,ttemp2,n,nm,n);
        mulmat2(zt21,qtd2,ttemp3,n,nm,nm);
        addmat1(ttemp2,ttemp3,ttemp2,n,nm);

/* Z1^{t(j)} Q12 + Z21^{t(j)} Q2 + Z1^t Q12^(j) + Z21^t Q2^(j) in temp2 */
        addmat1(ttemp2,temp2,temp2,n,nm);

        mulmat1(ptd1,qt12,ttemp2,n,nm,n); /* Z12^(j)  in vtt */ 
	mulmat1(pt1,qtd12,ttemp3,n,nm,n);
        addmat1(ttemp2,ttemp3,att,n,nm);

        mulmat1(ptd12,qt2,ttemp2,n,nm,nm);
        mulmat1(pt12,qtd2,ttemp3,n,nm,nm);
        addmat1(ttemp2,ttemp3,temp3,n,nm);
        addmat1(att,temp3,vtt,n,nm);
/* Q1^(j) Z12 + Q1 Z12^(j)  in temp3       */
        mulmat1(qtd1,zt12,temp3,n,nm,n);
        mulmat1(qt1,vtt,ttemp3,n,nm,n);
        addmat1(ttemp3,temp3,temp3,n,nm);
/* Q12^(j) Z2 + Q12 Z2^(j)    in rtt       */
        mulmat1(qtd12,zt2,ttemp3,n,nm,nm);
        mulmat1(qt12,ttemp1,att,n,nm,nm);
        addmat1(ttemp3,att,rtt,n,nm);
/* 1st term in ttemp2       */
        addmat1(temp3,rtt,ttemp3,n,nm);
        addmat1(ttemp3,temp2,ttemp2,n,nm);

/*  -0.5 r^-2 RC * the previous term in temp2       */
        mulmat1(rc,ttemp2,temp2,l,nm,n);
	eps = -0.5 *gaman2;
        scmat(eps,temp2,temp2,l,nm);

/* Z12^{t(j)} Q12 + Z12^t Q12^(j) in rtt        */ 
        mulmat2(vtt,qt12,att,nm,nm,n);
        mulmat2(zt12,qtd12,temp3,nm,nm,n);
        addmat1(att,temp3,rtt,nm,nm);
/*Q12^{t(j)} Z12 + Q12^t Z12^(j) in temp3         */
        mulmat2(qtd12,zt12,ttemp3,nm,nm,n);
        mulmat2(qt12,vtt,temp3,nm,nm,n);
        addmat1(temp3,ttemp3,temp3,nm,nm);
/* Z12^{t(j)} Q12+Z12^t Q12^(j)+Q12^{t(j)} Z12+Q12^t Z12^(j) in rtt */
        addmat1(rtt,temp3,rtt,nm,nm);

/* Z2^{t(j)} Q2 + Z2^t Q2^(j) in temp3        */ 
        mulmat2(ttemp1,qt2,ttemp2,nm,nm,nm);
        mulmat2(zt2,qtd2,ttemp3,nm,nm,nm);
        addmat1(ttemp2,ttemp3,temp3,nm,nm);
/*Q2^(j) Z2 + Q2^t Z2^(j) in ttemp2         */
        mulmat1(qtd2,zt2,ttemp3,nm,nm,nm);
        mulmat1(qt2,ttemp1,ttemp2,nm,nm,nm);
        addmat1(ttemp3,ttemp2,ttemp2,nm,nm);
/* Z2^{t(j)} Q2 + Z2^t Q2^(j)+Q2^(j) Z2 + Q2^t Z2^(j) in temp3  */
        addmat1(temp3,ttemp2,temp3,nm,nm);
/* 2nd term              */
        addmat1(rtt,temp3,ttemp2,nm,nm);
/* 0.5 r^-2 RCm * the previous term   in  temp3     */
        mulmat1(rcm,ttemp2,rtt,l,nm,nm);
	eps = - eps;
	scmat(eps,rtt,temp3,l,nm);
/* the sum of all previous term in temp3    */
        addmat1(temp2,temp3,temp3,l,nm);
} 
