#include "macro.h"
#include "eglobal.h"

extern void jaclam(), jacbm(), jaccm();

#if ((AIX) || (HP))
void rhojac(double *aa, double *lambda,double *x,double *y,int *kk,
#else
void rhojac_(double *aa, double *lambda,double *x,double *y,int *kk,
#endif

       double *p,int *ip)
 
/* RHOJAC evaluates kk-th column of Jacobian at given point.
*
* Input parameters: lambda,x - input point (lambda,x)
* kk - column number
*
* Output parameters:
* y - evaluated function
*/
{ 
      int ik,jl, k;

/* Derivatives with respect to Amij          */

   k = *kk;   
   if (k > 1 && k <= nm*nm+1){ 
      k--;
      compij(k,nm,ik,jl);
      jacam(*lambda, ik,jl,y);
      return;
  }

/* Derivatives with respect to Bmij          */

   if (k > 1 + nm*nm && k <= m*nm+nm*nm+1){ 
      k -= nm*nm + 1;
      compij(k,m,ik,jl);
      jacbm(*lambda, ik,jl,y);
      return;
    }
      
/* Derivatives with respect to Cmij          */

   if (k > m*nm + nm*nm + 1) {
      k -= m*nm + nm*nm + 1;
      compij(k,nm,ik,jl);
      jaccm(*lambda, ik,jl,y);
      return;
   }   

/* Derivatives with respect to lambda        */

   if (k == 1) {
       jaclam(*lambda,y);
    }
}


