#include <stdio.h>
#include "macro.h"
#include "eglobal.h"

extern FILE  *out;
extern void atxpxa(), riccnd();

#if ((AIX) || (HP))
void rho(double *aa,double *lambda,double x[],double y[],
#else
void rho_(double *aa,double *lambda,double x[],double y[],
#endif

	 double p[],double *ip)

/* RHO evaluates the homotopy map rho(a lambda,x) at a given point 
* Input parameters:lambda,x - input point (lambda,x)
* Output parameters: * y - evaluated function
*/
{ 
      register int i,j, k;
      int ind, nt4;
      double eps;
       
      /* Transfer x to (Bc, Cc)  */
      tomatrix(nc,l,bc,x);
      tomatrix(m,nc,cc,(x+nc*l));

      gama = *lambda * gf + (1- *lambda)* g0;   /* gamma   */
      gaman2 = 1/ (gama*gama);
 
      scmat(*lambda,adot,ttemp1,n,n);/* A0 + lambda*(A- A0) in temp1 */ 
      addmat1(a0,ttemp1,temp1,n,n);

      scmat(*lambda,bdot,ttemp1,n,m);/*  B0 + lambda *(B - B0) in bl*/
      addmat1(b0,ttemp1,bl,n,m);
 
      scmat(*lambda,cdot,ttemp1,l,n);/*  C0 + lambda *(C - C0) in cl*/
      addmat1(c0,ttemp1,cl,l,n);

      mulmat2(cc,cc,cctcc,nc,nc,m);
      mulmat3(bc,bc,bcbct,nc,nc,l);

      setmat(0.00,ome,nc,nc);
      for(i=0;i<nc;i++) ome[i][i] = cctcc[i][i]/bcbct[i][i];
      printf("Omega %19.10E\n",ome[0][0]);
      for(i=0;i<nc;i++){ 
        ac[i][i] =  0.50*(cctcc[i][i] - bcbct[i][i]);
        for(j=0;j<nc;j++)
         if(j != i)
          ac[i][j]=(ome[j][j]*bcbct[i][j]*(1+ome[i][i]) -
                   cctcc[i][j]*(1 + ome[j][j]))/(ome[i][i]-ome[j][j]) ;
        }


/*****************************************************************/

      mulmat1(bl,cc,temp4,n,nc,m);
      mulmat1(bc,cl,temp3,nc,n,l);

      tkblockf(at,temp1,temp4,temp3,ac,n,nt);  /* A tilde */
      trarray(at,uat,nt,nt);

      scmat(*lambda,r1idot,ttemp1,n,n);/* R1i0+lambda*(R1i - R1i0) in temp3*/
      addmat1(r1i0,ttemp1,temp3,n,n);

      scmat(*lambda,r2idot,ttemp1,m,m);/* R2i0+lambda*(R2i - R2i0) in temp4*/
      addmat1(r2i0,ttemp1,temp4,m,m);
 
      mulmat1(temp4,cc,r2icc,m,nc,m); /*  Cc^T R_2 infty Cc */
      mulmat2(cc,r2icc,cctr2icc,nc,nc,m);
 
      tkblockp(rti,temp3,cctr2icc,n,nt); /* R tilde infty*/
      scmat(gaman2,rti,rtt,nt,nt);
      scmat(-1.0,rtt,ttemp1,nt,nt);
      tmparray(ttemp1,vat,nt,nt);

      scmat(*lambda,v1dot,ttemp1,n,n);/* V10 + lambda *(V1 - V10) in temp3*/
      addmat1(v10,ttemp1,temp3,n,n);

      scmat(*lambda,v2dot,ttemp1,l,l);/* V20 + lambda *(V2 - V20) in temp4*/
      addmat1(v20,ttemp1,temp4,l,l);

      mulmat1(bc,temp4,bcv2,nc,l,l); /* Bc V_2 Bc^T  */
      mulmat3(bcv2,bc,bcv2bct,nc,nc,l);

      tkblockp(vt,temp3,bcv2bct,n,nt); /* V tilde */
      tmparray(vt,ua,nt,nt);

/* Solve At Q + Q At'  + r^-2 Q Rt Q + Vt =0 */ 

       nt4 = nt2 + 2;
#if ((AIX) || (HP))
       riccnd(&nt12,&nt12,&nt12,&nt4,&nt,&nt2,uat,vat,ua,
#else
       riccnd_(&nt12,&nt12,&nt12,&nt4,&nt,&nt2,uat,vat,ua,
#endif

	tarray1,tarray2,er,ei,work,scal,itype,ipvl,ipvs);   
 
       tmpmatrix(ua,qt,nt,nt);
       partition(qt,qt1,qt12,qt2,n,nt);

/* Check the solution of the above equation                 */

       mulmat1(at,qt,ttemp2,nt,nt,nt);
       trans(ttemp2,ttemp3,nt,nt);
       addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
       addmat1(ttemp1,vt,ttemp2,nt,nt);
       mulmat1(qt,rtt,ttemp1,nt,nt,nt);
       mulmat1(ttemp1,qt,ttemp3,nt,nt,nt);
       addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
       
       eps = 0.0e0;
       for(i=0;i<nt;i++)for(j=0;j<nt;j++) eps += myabs(ttemp1[i][j]);
       eps /= ntt2;
       if(eps > 1.0e-4){
         printf("The precision in solving Ricatti equation is %E \n",eps);
         fprintf(out,"The Ricatti equation is %E \n",eps);
        }

/**************************************************************/

/* Solve (At + r*r Q Rti)^t P  + P (At + r*r Q Rti) + Rt =0  */ 

      scmat(*lambda,r1dot,ttemp1,n,n);/*  R10 + lambda *(R1 - R10) in temp3*/
      addmat1(r10,ttemp1,temp3,n,n);

      scmat(*lambda,r2dot,ttemp1,m,m);/*  R20 + lambda *(R2 - R20) in temp4*/
      addmat1(r20,ttemp1,temp4,m,m);
 
      mulmat1(temp4,cc,r2cc,m,nc,m); /*  Cc^T R_2 infty Cc */
      mulmat2(cc,r2cc,cctr2cc,nc,nc,m);
 
      tkblockp(rt,temp3,cctr2cc,n,nt); /* R tilde */
      scmat(-1.0,rt,ttemp1,nt,nt);
      tmparray(ttemp1,tarray2,nt,nt);

       mulmat1(qt,rtt,ttemp1,nt,nt,nt);
       addmat1(at,ttemp1,ttemp3,nt,nt);
       tmparray(ttemp3,uat,nt,nt);

      eps = 1.0e-26;
#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif


      tmpmatrix(tarray2,pt,nt,nt);
      partition(pt,pt1,pt12,pt2,n,nt);

/**************************************************************/

      mulmat2(pt12,qt12,ttemp1,nc,nc,n);/* Compute H-Ac */
      mulmat1(pt2,qt2,ttemp2,nc,nc,nc);
      addmat1(ttemp1,ttemp2,ttemp3,nc,nc); /* used in H_Cc */

      for(j=0;j<nc;j++){ /* Compute Mo    */
         for(i=j+1;i<nc;i++){
          mo[i][j] = (ttemp3[i][j]-ttemp3[j][i]) /(ome[j][j]-ome[i][i]);
          mo[j][i] = mo[i][j];}
        }
      for(i=0;i<nc;i++){
        mo[i][i] = 0.0;
        for(j=0; j<i;j++) mo[i][i] +=  ac[i][j]*mo[j][i] +
                               bcbct[i][j] * ome[j][j] * mo[j][i];
        for(j=i+1; j<nc;j++) mo[i][i] +=  ac[i][j]*mo[j][i] +
                               bcbct[i][j] * ome[j][j] * mo[j][i];
        mo[i][i] /= - (ac[i][i] + bcbct[i][i] * ome[i][i]);
       }

      for(i=0;i<nc;i++) /* Compute Mc    */
        for(j=0; j<nc;j++)
           mc[i][j] = - ttemp3[i][j] - ome[i][i] * mo[i][j];

      mulmat2(pt12,qt1,ttemp1,nc,n,n);  /* The homotopy H_Bc */ 
      mulmat3(pt2,qt12,ttemp2,nc,n,nc);
      addmat1(ttemp1,ttemp2,temp4,nc,n); /* temp4 used in jaclam */
      mulmat3(temp4,cl,ttemp1,nc,l,n);

      mulmat1(pt2,bcv2,ttemp2,nc,l,nc);
      addmat1(ttemp1,ttemp2,temp2,nc,l);

      for(i=0;i<nc;i++) /* Compute Omega Mo Omega    */
        for(j=0; j<nc;j++)
           ttemp1[i][j] = ome[i][i] * mo[i][j]* ome[j][j];
      addmat3(mc,ttemp1,ttemp2,nc,nc);
      mulmat1(ttemp2,bc,ttemp1,nc,l,nc);

      addmat1(temp2,ttemp1,ttemp2,nc,l);

      toarray(nc,l,ttemp2,yrho);

      trans(ttemp3,ttemp1,nc,nc); /* The homotopy H_Cc */
      mulmat1(ttemp1,qt2,temp3,nc,nc,nc); /* Last term */

      mulmat2(qt12,pt1,ttemp1,nc,n,n);
      mulmat3(qt2,pt12,ttemp2,nc,n,nc);
      addmat1(ttemp1,ttemp2,ttemp1,nc,n); /* ttemp1 used */
      mulmat1(ttemp1,qt12,ttemp2,nc,nc,n);

      addmat1(temp3,ttemp2,cy,nc,nc);
      mulmat1(r2icc,cy,ttemp2,m,nc,nc);
      eps = 0.5* gaman2;
      scmat(eps,ttemp2,temp3,m,nc);  /* The last term */

      trans(ttemp1,temp2,nc,n);        /* temp2 used in jaclam */
      mulmat2(bl,temp2,ttemp1,m,nc,n); /* The middle term  */

      addmat1(ttemp1,temp3,temp3,m,nc); /* Sum of the last two terms */

      mulmat1(r2cc,qt2,ttemp1,m,nc,nc);  /* The first term */

      addmat1(ttemp1,temp3,ttemp2,m,nc); /* H_Cc    */
       
      addmat3(mo,mc,ttemp1,nc,nc);
      mulmat1(cc,ttemp1,temp3,m,nc,nc);
       
      addmat1(ttemp2,temp3,ttemp2,m,nc);

      toarray(m,nc,ttemp2,(yrho+l*nc));
      for (i=0;i<nn;i++)
        y[i] = *lambda * yrho[i] + (1 - *lambda) * (x[i]-x0[i]);

}
